const Video = Twilio.Video;
const createLocalVideoTrack = Twilio.Video;

document.getElementById('button-preview').onclick = function() {

    createLocalVideoTrack.createLocalTracks().then(function(localTracks) {
    var localMediaContainer = document.getElementById('local-media');

    previewTracks = localTracks;

    if (!localMediaContainer.querySelector('video')) {
            //attachTracks(tracks, previewContainer);
        localTracks.forEach(function(track) {
            localMediaContainer.appendChild(track.attach());
        });

        $("#button-join").click();

    }

    }, function(error) {
        console.error('Unable to access local media', error);
    });    

}

$.getJSON('token-user.php', function(data) {

    identity = data.identity;

    document.getElementById('room-controls').style.display = 'block';

    document.getElementById('button-join').onclick = function() {
        console.log('All Done');
        var roomName = 'Parth_5kpC9dva6g';
        //var roomName = document.getElementById('room-name').value;
        
        if (roomName) {
            console.log("Joining room '" + roomName + "'...");

            var connectOptions = {
                name: roomName,
                dominantSpeaker: true,
                logLevel: false
            };
            if (previewTracks) {
                connectOptions.tracks = previewTracks;
            }

            Video.connect(data.token, { name:roomName}).then(roomJoined, function(error) {
                console.log('Could not connect to Twilio: ' + error.message);
                //update_video_call_status(user_id, call_status = 0, booking_id);
                //update_answer_status(user_id, ring_status = 0, booking_id);
            });
            
        } else {
            alert('Please enter a room name.');
        }


    }    


});

function roomJoined(room) {

    activeRoom = room;
    console.log("Joined as '" + identity + "'");

    document.getElementById('button-join').style.display = 'none';
    document.getElementById('button-leave').style.display = 'inline';

    // Log your Client's LocalParticipant in the Room
    const localParticipant = room.localParticipant;
    console.log(`Connected to the Room as LocalParticipant "${localParticipant.identity}"`);

    // Log any Participants already connected to the Room
    room.participants.forEach(participant => {
      console.log(`Participant "${participant.identity}" is connected to the Room`);
    });

    // Log new Participants as they connect to the Room
    room.once('participantConnected', participant => {
      console.log(`Participant "${participant.identity}" has connected to the Room`);
    });

    // Log Participants as they disconnect from the Room
    room.once('participantDisconnected', participant => {
      console.log(`Participant "${participant.identity}" has disconnected from the Room`);
    });

    // Attach the Participant's Media to a <div> element.
    room.on('participantConnected', participant => {
        console.log(`Participant "${participant.identity}" connected`);

        participant.tracks.forEach(publication => {
            if (publication.isSubscribed) {
              const track = publication.track;
              document.getElementById('remote-media').appendChild(track.attach());
            }
        });

        participant.on('trackSubscribed', track => {
            document.getElementById('remote-media').appendChild(track.attach());
        });
    });

    room.participants.forEach(participant => {
      participant.tracks.forEach(publication => {
        if (publication.track) {
          document.getElementById('remote-media').appendChild(publication.track.attach());
        }
      });

     participant.on('trackSubscribed', track => {
        document.getElementById('remote-media').appendChild(track.attach());
      });
    });
    
}

